#
# Author: Christophe Mertz  mertz@intuilab.com
#

# this test mainly does funny effects when openGL is on

lappend auto_path .
package require Tkzinc 3.3

zinc .z -width 200 -height 200 -backcolor white -render 1
pack .z

.z add text 1 -position {10 5} -text {the gradient fills a rectangle 
which is clipped by the curve 
made of two circles...}
 

.z add arc 1 {20 20 180 180} -tags Circle1
.z add arc 1 {70 70 130 130} -tags Circle2

set curve [.z add curve 1 {} -fillcolor red -filled 1 -linewidth 1 -tags Curve]
.z contour Curve add 1 Circle1
.z contour Curve add -1 Circle2

.z remove Circle1
.z remove Circle2

proc test1 { } {
  for {set j 0} {$j < 4} {incr j} { 
    for {set i 0} {$i <= 360} {incr i} {
      set gradient "=axial $i | red | white 50 | blue"
#      if { $i % 2 } {
#        set gradient red 
#      } else {
#        set gradient blue
#      }
      .z itemconfigure Curve -fillcolor $gradient 
      update
    }
  }
}

set t [time test1]
puts "Time for test 1: $t"

puts "turning gradient one side"

for {set j 0} {$j < 4} {incr j} {
  for {set i 0} {$i < 100} {incr i} {
    .z translate $curve 0.5 0.5
    update;
  }
  for {set i 0} {$i < 800} {incr i} {
    .z rotate $curve [expr {3.14159/400}] 100 100
    update
  }
  for {set i 0} {$i < 100} {incr i} {
    .z translate $curve 0.5 0.5
    update
  }
  
  for {set i 0} {$i < 400} {incr i} {
    .z translate $curve -0.5 -0.5
    update
  }
  for {set i 0} {$i < 200} {incr i} {
    .z translate $curve 0.5 0.5
    update
  }
  puts "shaking the circle around"
}

for {set j 0} {$j < 4} {incr j} { 
  for {set i 359} {$i > 0} {incr i -1} {
    set gradient "=axial $i | red | white 50 | blue"
    .z itemconfigure $curve -fillcolor $gradient 
    update
  }
}
puts "turning gradient the other side"

set gr [.z add group 1]
set rect [.z add rectangle $gr {0 -480 200 180} -filled 1 \
            -fillcolor "=axial 90 |blue|white 10|red 20|white 30|blue 40|white 50|red 60|white 70|blue 80|white 90|red"]

.z chggroup $curve $gr
.z itemconfigure $curve -visible 0

.z itemconfigure $gr -clip $curve

puts "displaying a translated rectangle filled with froggy colors and clipped by two circles"
for {set j 0} {$j < 2} {incr j} {
  for {set i 0} {$i < 500} {incr i} {
    .z translate $rect 0 1
    update
  }
  for {set i 0} {$i < 500} {incr i} {
    .z translate $rect 0 -1
    update
  }
  puts "a thousand translation"
}

.z translate $rect 0 250

for {set j 0} {$j < 1000} {incr j} {
  .z scale $rect 1 0.998 100 100
  update
}
puts "a thousand scaling down"

for {set j 0} {$j < 360} {incr j} {
  .z rotate $rect [expr {3.14159/180}] 100 100
  update
}
puts "360 rotation of 1"

for {set j 0} {$j < 360} {incr j} {
  .z rotate $rect [expr {-3.14159/180}] 100 100
  update
}
puts "360 rotation of 1"

for {set j 0} {$j < 360} {incr j} {
  .z rotate $rect [expr {-3.14159/180}] 100 100
  update
}

for {set j 0} {$j < 1000} {incr j} {
  .z scale $rect 1 [expr {1/0.998}] 100 100
  update
}
puts "a thousand scaling up"

for {set j 0} {$j < 4} {incr j} {
  for {set i 0} {$i < 200} {incr i} {
    .z itemconfigure $gr -alpha [expr {(200-$i)/2}]
    update
  }
  for {set i 0} {$i < 200} {incr i} {
    .z itemconfigure $gr, -alpha [expr {$i/2}]
    update
  }
  puts "fade out/in in 400 steps"
}

puts "That's all folks"
exit
