lappend auto_path .
package require Tkzinc

set color \#ac5500
set selColor RoyalBlue4

set zincWidth 1200
set zincHeight 1100

proc createZinc { } {
  global zincWidth zincHeight

  zinc .z -backcolor grey -relief sunken -width $zincWidth -height $zincHeight \
           -borderwidth 0 -highlightthickness 0 -render 0
  pack .z -side top -expand 1 -fill both
  .z add group 1 -tags {radar controls}
  .z configure -pickaperture 2
}

proc createWptConnections { } {
  global color

  set x 100
  set y0 100
  for {set i 0} {$i < 1} {incr i} {
    incr x 200
    set y $y0
    set connected 0
    for {set j 0} {$j < 12} {incr j} {
      set wp [.z add waypoint radar 2 -position [list $x $y] \
                -connectioncolor $color -connectionwidth 2 -symbolcolor [expr {$j==0 ? "black" : "$color"}]]
      #no enter/leave on connections for 3.3.0 and 3.3.2 Zinc version
      #(ok for 3.2.96 Zinc version only):
      if { $connected != 0 } {            
       .z itemconfigure $connected -connecteditem $wp
      #--------------------------------------------------------------
      #ok with all Zinc versions:
#       .z itemconfigure $wp -connecteditem $connected
      #--------------------------------------------------------------
      }
      .z bind "$wp:connection" <Enter> {enterConnect %W}
      .z bind "$wp:connection" <Leave> {leaveConnect %W}
      if { $j < 6 } {
        incr x 30
        incr y [expr {50 * $j}]
      } else {
        incr x -30
        incr y [expr {-50 * ($j - 6)}]
      }
      set connected $wp        
    }
  }
}

proc createBBoxes { } {
  foreach w [.z find withtype waypoint] {
    set bbox [.z bbox $w]
    .z add rectangle radar $bbox -linecolor pink
  }
}

proc enterConnect { w } {
  global selColor

  $w itemconfigure current -connectioncolor $selColor
  puts "entre dans [$w find withtag current]"
}
        
proc leaveConnect { w } {
  global color
  
  $w itemconfigure current -connectioncolor $color
}
            
set zincVersionInfo [zinc]

puts "tkzinc version $zincVersionInfo"
createZinc
createWptConnections
createBBoxes
