lappend auto_path .

package require Tkzinc

set zinc [zinc .z -render 1 -width 500 -height 500 -borderwidth 0 -highlightthickness 0]
pack $zinc

set myGroup [$zinc add group 1]

#
# Create a pile of three groups, the inner one
# will host the items to be rotated.
# The inner and outer groups act as a translation
# adapter and are translated according to the
# center of gravity.
# The middle group performs the scale/rotation around
# the center of gravity.
# The whole set is reusable as a tool for each item
# that need rotation.
.z add group $myGroup -tags rotAdapter
.z add group rotAdapter -tags rotAdapterRot
.z add group rotAdapterRot -tags rotAdapterShell

set mySquare [$zinc add curve $myGroup {0 0 0 100 100 100 100 0 0 0}]
set myIcon [$zinc add icon $myGroup -anchor center -mask AtcSymbol11 -position {0 0}]
$zinc translate $myIcon 50 50
$zinc translate $myGroup 100 100

#
# Here the adapters are tuned to the center of gravity
.z translate rotAdapter 50 50
.z translate rotAdapterShell -50 -50
#
# The items to be rotated are put into the shell
.z chggroup $mySquare rotAdapterShell true
.z chggroup $myIcon rotAdapterShell true

#
# Then scale and rotate at will
.z rotate rotAdapterRot 45 true

#set center [$zinc transform $mySquare 1 {50 50}]
#foreach {x y} $center break

#$zinc translate $myGroup -$x -$y
#$zinc rotate $myGroup 45 true
#$zinc translate $myGroup $x $y

#$zinc rotate $myGroup 45 true $x $y
